/*setup includes*/
#include <windows.h>
#include <stdio.h>
#include <commctrl.h>
#include "tasks.h"
#include "../../lssrc/ls-b24/lsapi/lsapi.h"

/*setup constants*/
const char szAppName[] = "Tasks";
const char rcsRevision[] = "$Revision: 0.80 $"; // Our Version
const char rcsId[] = "$Id: tasks.cpp,v 0.80 1999/12/25 00:22:00 jugg $"; // The Full RCS ID.

/*setup variables*/
IconList *iconTag = NULL;
AddList *addTag = NULL;
IgnoreList *ignoreTag = NULL;
PixList *pixTag = NULL;
TaskType *tasks = NULL;
TasksSettings ts;

BOOL taskWrap, bgImgNone, minBgImgNone, selBgImgNone;
BOOL moveOnce, bFixFocus;
char path[MAXLEN];
HCURSOR normalCursor, movingCursor;
HINSTANCE dll;
HWND parent, mainWin, deskTop, hints, curTask, lockCurTask, oldCurTask;
int numIcon, numAdd, numIgnore, numPix, numTasks, tmpNumTasks, prevTasks;
int screenHeight, screenWidth;
int bkUpX, bkUpY;
int captureTask;
RECT rAllTasks;
POINT oldCursorPos;
UINT timer;

/*declare all the functions*/
BOOL GetTasksAdd(char *addTitle);
BOOL GetTasksIgnore(char *ignoreTitle);
BOOL IsAppWindow(HWND hwnd);
BOOL IsValidWindow(HWND hwnd);
BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam);
HICON GetIconFromWindow(HWND hwnd, BOOL bBigIcon);
LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
int InWinList(HWND hwnd);
int GetTaskByWnd(HWND hwnd);
int GetTaskByAppWnd(HWND hwnd);
int GetUnMovedNrTasks(void);
void CreateHints(HWND hwnd, char *txt);
void CreateTask(int i, HWND handle);
void DeleteTask(int i);
void GetNewTaskPos(int i);
void UpdateTasks(void);
void GetTasksIcon(int n);
void GetTasksPix(int n);
void HideMinAppBar(HWND hwnd);
void CopyTasks(int i);
void PackList(void);
void PaintTask(int i);
void ReadTasksIcon(void);
void ReadTasksAdd(void);
void ReadTasksIgnore(void);
void ReadTasksPix(void);
void ReArrangeTasks(BOOL all);
void RemoveHints(HWND hwnd);
void TaskPosition(int i, int tmpNumTasks);
void UpdateHints(HWND hwnd, char *txt);
/*The rest are !bang commands*/
void TasksOnBottom(void);
void TasksGather(void);
void TasksHide(void);
void TasksMove(HWND caller, char *args);
void TasksShow(void);
void TasksSwitch(HWND caller, char *args);
void TasksToggle(void);
void TasksOnTop(void);

/*and here are all the functions*/
TasksSettings ReadSettings()
{
	TasksSettings settings;
	char tmp[MAXLEN];

	*tmp = '\0';
	GetRCString("TasksDirection", tmp, "right", 10); // the largest size is 5, but in case of typo's or something...
			settings.Direction = 2;  /*only needed if user enters an invalid parameter*/
		if (strcmpi(tmp, "up") == 0)
			settings.Direction = 1;
		else if (strcmpi(tmp, "right") == 0)
			settings.Direction = 2;
		else if (strcmpi(tmp, "down") == 0)
			settings.Direction = 3;
		else if (strcmpi(tmp, "left") == 0)
			settings.Direction = 4;

	settings.DragDistance = GetRCInt("TasksDragDistance", 4);
		if (settings.DragDistance < 0) settings.DragDistance = 4;
	settings.MaxTiles = GetRCInt("TasksMaxTiles", 0);
		if (settings.MaxTiles < 0) settings.MaxTiles = 0;
	settings.SpacingX = GetRCInt("TasksSpacingX", 0);
	settings.SpacingY = GetRCInt("TasksSpacingY", 0);
	settings.WrapCount = GetRCInt("TasksWrapCount", 0);
		if (settings.WrapCount < 1)
			taskWrap = false;
		else
			taskWrap = true;

	*tmp = '\0';
	GetRCString("TasksWrapDirection", tmp, "down", 10); // the largest size is 5, but in case of typo's or something...
			settings.WrapDirection = 3;  /*only needed if user enters an invalid parameter*/
		if (strcmpi(tmp, "up") == 0)
			settings.WrapDirection = 1;
		else if (strcmpi(tmp, "right") == 0)
			settings.WrapDirection = 2;
		else if (strcmpi(tmp, "down") == 0)
			settings.WrapDirection = 3;
		else if (strcmpi(tmp, "left") == 0)
			settings.WrapDirection = 4;

	settings.Height = GetRCInt("TasksHeight", 32);
		if (settings.Height < 2) settings.Height = 32;
	settings.Width = GetRCInt("TasksWidth", 32);
		if (settings.Width < 2) settings.Width = 32;
	settings.X = GetRCInt("TasksX", 0);
		bkUpX = settings.X;
	settings.Y = GetRCInt("TasksY", 0);
		bkUpY = settings.Y;

	settings.IconSize = GetRCInt("TasksIconSize", 16);
		if (settings.IconSize < 2) settings.IconSize = 16;

	settings.IconX = GetRCInt("TasksIconX", -2);
		if (settings.IconX < 0)
		{
			if (settings.IconX == -1)
				settings.IconX = 1;
			else if (settings.IconX == -3)
				settings.IconX = settings.Width - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.IconX = settings.Width/2 - settings.IconSize/2;
		}
	settings.MinIconX = GetRCInt("TasksMinIconX", settings.IconX);
		if (settings.MinIconX < 0)
		{
			if (settings.MinIconX == -1)
				settings.MinIconX = 1;
			else if (settings.MinIconX == -3)
				settings.MinIconX = settings.Width - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.MinIconX = settings.Width/2 - settings.IconSize/2;
		}
	settings.SelIconX = GetRCInt("TasksSelIconX", settings.IconX);
		if (settings.SelIconX < 0)
		{
			if (settings.SelIconX == -1)
				settings.SelIconX = 1;
			else if (settings.SelIconX == -3)
				settings.SelIconX = settings.Width - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.SelIconX = settings.Width/2 - settings.IconSize/2;
		}

	settings.IconY = GetRCInt("TasksIconY", -2);
		if (settings.IconY < 0)
		{
			if (settings.IconY == -1)
				settings.IconY = 1;
			else if (settings.IconY == -3)
				settings.IconY = settings.Height - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.IconY = settings.Height/2 - settings.IconSize/2;
		}
	settings.MinIconY = GetRCInt("TasksMinIconY", settings.IconY);
		if (settings.MinIconY < 0)
		{
			if (settings.MinIconY == -1)
				settings.MinIconY = 1;
			else if (settings.MinIconY == -3)
				settings.MinIconY = settings.Height - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.MinIconY = settings.Height/2 - settings.IconSize/2; //Center the Icon by default for any other negative value.
		}
	settings.SelIconY = GetRCInt("TasksSelIconY", settings.IconY);
		if (settings.SelIconY < 0)
		{
			if (settings.SelIconY == -1)
				settings.SelIconY = 1;
			else if (settings.SelIconY == -3)
				settings.SelIconY = settings.Height - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.SelIconY = settings.Height/2 - settings.IconSize/2; //Center the Icon by default for any other negative value.
		}

	settings.PixX = GetRCInt("TasksPixX", 1);
	settings.MinPixX = GetRCInt("TasksMinPixX", settings.PixX);
	settings.SelPixX = GetRCInt("TasksSelPixX", settings.PixX);

	settings.PixY = GetRCInt("TasksPixY", 1);
	settings.MinPixY = GetRCInt("TasksMinPixY", settings.PixY);
	settings.SelPixY = GetRCInt("TasksSelPixY", settings.PixY);

	settings.AlwaysOnTop = GetRCBool("TasksAlwaysOnTop", TRUE);
	settings.AutoArrange = GetRCBool("TasksAutoArrange", TRUE);
	settings.HideMinAppBar = GetRCBool("TasksHideMinAppBar", TRUE);
	settings.HideOnClick = GetRCBool("TasksHideOnClick", TRUE);
	settings.InjTray = GetRCBool("TasksInjTray", TRUE);
	settings.MoveAll = GetRCBool("TasksMoveAll", TRUE);
	settings.NoMinimizeOnClick = GetRCBool("TasksNoMinimizeOnClick", TRUE);
	settings.NoMove = GetRCBool("TasksNoMove", TRUE);
	settings.OnlyMinimized = GetRCBool("TasksOnlyMinimized", TRUE);
	settings.HideMinimized = GetRCBool("TasksHideMinimized", TRUE);
	settings.StartHidden = GetRCBool("TasksStartHidden", TRUE);

	settings.NoHints = GetRCBool("TasksNoHints", TRUE);
	settings.NoIcons = GetRCBool("TasksNoIcons", TRUE);
	settings.HighLightMinimized = GetRCBool("TasksHighLightMinimized", TRUE);
	settings.HighLightSelected = GetRCBool("TasksHighLightSelected", TRUE);
	settings.UseWindowsSettings = GetRCBool("TasksUseWindowsSettings", TRUE);

	settings.BgColor = GetRCColor("TasksBgColor", 0xFF00FF);
	settings.MinBgColor = GetRCColor("TasksMinBgColor", settings.BgColor);
	settings.SelBgColor = GetRCColor("TasksSelBgColor", settings.BgColor);

	settings.DarkColor = GetRCColor("TasksDarkColor", 0xFF00FF);
	settings.MinDarkColor = GetRCColor("TasksMinDarkColor", settings.DarkColor);
	settings.SelDarkColor = GetRCColor("TasksSelDarkColor", settings.DarkColor);

	settings.LightColor = GetRCColor("TasksLightColor", 0xFF00FF);
	settings.MinLightColor = GetRCColor("TasksMinLightColor", settings.LightColor);
	settings.SelLightColor = GetRCColor("TasksSelLightColor", settings.LightColor);

	*tmp = '\0';
	GetRCString("TasksBgImage", tmp, ".none", MAXLEN);
			bgImgNone = true;
		if (strcmpi(".none", tmp))
		{
			settings.BgImage = LoadLSImage(tmp, NULL);
			bgImgNone = false;
		}
		else
			settings.BgImage = NULL;

	*tmp = '\0';
	GetRCString("TasksMinBgImage", tmp, "", MAXLEN); /*By using "" as the default, it uses the TasksBackImage.*/
			minBgImgNone = false;
		if (strcmpi(".none", tmp))
			settings.MinBgImage = LoadLSImage(tmp, NULL);
		else
		{
			settings.MinBgImage = NULL;
			minBgImgNone = true;
		}

	*tmp = '\0';
	GetRCString("TasksSelBgImage", tmp, "", MAXLEN); /*By using "" as the default, it uses the TasksBackImage.*/
			selBgImgNone = false;
		if (strcmpi(".none", tmp))
			settings.SelBgImage = LoadLSImage(tmp, NULL);
		else
		{
			settings.SelBgImage = NULL;
			selBgImgNone = true;
		}

	settings.TitleHeight = GetRCInt("TasksTitleHeight", 12); /*The Title settings here align it centered along the bottom of a 32x32 tile.*/
		if (settings.TitleHeight < 2) settings.TitleHeight = 12;
	settings.TitleMinHeight = GetRCInt("TasksTitleMinHeight", settings.TitleHeight); /*The Title settings here align it centered along the bottom of a 32x32 tile.*/
		if (settings.TitleMinHeight < 2) settings.TitleMinHeight = settings.TitleHeight;
	settings.TitleSelHeight = GetRCInt("TasksTitleSelHeight", settings.TitleHeight); /*The Title settings here align it centered along the bottom of a 32x32 tile.*/
		if (settings.TitleSelHeight < 2) settings.TitleSelHeight = settings.TitleHeight;

	settings.TitleWidth = GetRCInt("TasksTitleWidth", 28);
		if (settings.TitleWidth < 2) settings.TitleWidth = 28;
	settings.TitleMinWidth = GetRCInt("TasksTitleMinWidth", settings.TitleWidth);
		if (settings.TitleMinWidth < 2) settings.TitleMinWidth = settings.TitleWidth;
	settings.TitleSelWidth = GetRCInt("TasksTitleSelWidth", settings.TitleWidth);
		if (settings.TitleSelWidth < 2) settings.TitleSelWidth = settings.TitleWidth;

	settings.TitleX = GetRCInt("TasksTitleX", -2);
		if (settings.TitleX < 0)
		{
			if (settings.TitleX == -1)
				settings.TitleX = 1;
			else if (settings.TitleX == -3)
				settings.TitleX = settings.Width - settings.TitleWidth - 1;
			else /*Center the Title for '-2' and by default for any other negative value.*/
				settings.TitleX = settings.Width/2 - settings.TitleWidth/2;
		}
	settings.TitleMinX = GetRCInt("TasksTitleMinX", settings.TitleX);
		if (settings.TitleMinX < 0)
		{
			if (settings.TitleMinX == -1)
				settings.TitleMinX = 1;
			else if (settings.TitleMinX == -3)
				settings.TitleMinX = settings.Width - settings.TitleMinWidth - 1;
			else /*Center the Title for '-2' and by default for any other negative value.*/
				settings.TitleMinX = settings.Width/2 - settings.TitleMinWidth/2;
		}
	settings.TitleSelX = GetRCInt("TasksTitleSelX", settings.TitleX);
		if (settings.TitleSelX < 0)
		{
			if (settings.TitleSelX == -1)
				settings.TitleSelX = 1;
			else if (settings.TitleSelX == -3)
				settings.TitleSelX = settings.Width - settings.TitleSelWidth - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.TitleSelX = settings.Width/2 - settings.TitleSelWidth/2;
		}

	settings.TitleY = GetRCInt("TasksTitleY", -3);
		if (settings.TitleY < 0)
		{
			if (settings.TitleY == -1)
				settings.TitleY = 1;
			else if (settings.TitleY == -3)
				settings.TitleY = settings.Height - settings.TitleHeight - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.TitleY = settings.Height/2 - settings.TitleHeight/2;
		}
	settings.TitleMinY = GetRCInt("TasksTitleMinY", settings.TitleY);
		if (settings.TitleMinY < 0)
		{
			if (settings.TitleMinY == -1)
				settings.TitleMinY = 1;
			else if (settings.TitleMinY == -3)
				settings.TitleMinY = settings.Height - settings.TitleMinHeight - 1;
			else /*Center the Title for '-2' and by default for any other negative value.*/
				settings.TitleMinY = settings.Height/2 - settings.TitleMinHeight/2;
		}
	settings.TitleSelY = GetRCInt("TasksTitleSelY", settings.TitleY);
		if (settings.TitleSelY < 0)
		{
			if (settings.TitleSelY == -1)
				settings.TitleSelY = 1;
			else if (settings.TitleSelY == -3)
				settings.TitleSelY = settings.Height - settings.TitleSelHeight - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.TitleSelY = settings.Height/2 - settings.TitleSelHeight/2;
		}

	settings.TitleIconX = GetRCInt("TasksTitleIconX", -2);
		if (settings.TitleIconX < 0)
		{
			if (settings.TitleIconX == -1)
				settings.TitleIconX = 1;
			else if (settings.TitleIconX == -3)
				settings.TitleIconX = settings.Width - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.TitleIconX = settings.Width/2 - settings.IconSize/2;
		}
	settings.TitleMinIconX = GetRCInt("TasksTitleMinIconX", settings.TitleIconX);
		if (settings.TitleMinIconX < 0)
		{
			if (settings.TitleMinIconX == -1)
				settings.TitleMinIconX = 1;
			else if (settings.TitleMinIconX == -3)
				settings.TitleMinIconX = settings.Width - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.TitleMinIconX = settings.Width/2 - settings.IconSize/2;
		}
	settings.TitleSelIconX = GetRCInt("TasksTitleSelIconX", settings.TitleIconX);
		if (settings.TitleSelIconX < 0)
		{
			if (settings.TitleSelIconX == -1)
				settings.TitleSelIconX = 1;
			else if (settings.TitleSelIconX == -3)
				settings.TitleSelIconX = settings.Width - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.TitleSelIconX = settings.Width/2 - settings.IconSize/2;
		}

	settings.TitleIconY = GetRCInt("TasksTitleIconY", -1);
		if (settings.TitleIconY < 0)
		{
			if (settings.TitleIconY == -1)
				settings.TitleIconY = 1;
			else if (settings.TitleIconY == -3)
				settings.TitleIconY = settings.Height - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.TitleIconY = settings.Height/2 - settings.IconSize/2;
		}
	settings.TitleMinIconY = GetRCInt("TasksTitleMinIconY", settings.TitleIconY);
		if (settings.TitleMinIconY < 0)
		{
			if (settings.TitleMinIconY == -1)
				settings.TitleMinIconY = 1;
			else if (settings.TitleMinIconY == -3)
				settings.TitleMinIconY = settings.Height - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.TitleMinIconY = settings.Height/2 - settings.IconSize/2; //Center the Icon by default for any other negative value.
		}
	settings.TitleSelIconY = GetRCInt("TasksTitleSelIconY", settings.TitleIconY);
		if (settings.TitleSelIconY < 0)
		{
			if (settings.TitleSelIconY == -1)
				settings.TitleSelIconY = 1;
			else if (settings.TitleSelIconY == -3)
				settings.TitleSelIconY = settings.Height - settings.IconSize - 1;
			else /*Center the Icon for '-2' and by default for any other negative value.*/
				settings.TitleSelIconY = settings.Height/2 - settings.IconSize/2; //Center the Icon by default for any other negative value.
		}

	settings.TitlePixX = GetRCInt("TasksTitlePixX", 1);
	settings.TitleMinPixX = GetRCInt("TasksTitleMinPixX", settings.TitlePixX);
	settings.TitleSelPixX = GetRCInt("TasksTitleSelPixX", settings.TitlePixX);

	settings.TitlePixY = GetRCInt("TasksTitlePixY", 1);
	settings.TitleMinPixY = GetRCInt("TasksTitleMinPixY", settings.TitlePixY);
	settings.TitleSelPixY = GetRCInt("TasksTitleSelPixY", settings.TitlePixY);

	settings.TitleFontSize = GetRCInt("TasksTitleFontSize", 10);
		if (settings.TitleFontSize < 2) settings.TitleFontSize = 10;
	settings.TitleMinFontSize = GetRCInt("TasksTitleMinFontSize", settings.TitleFontSize);
		if (settings.TitleMinFontSize < 2) settings.TitleMinFontSize = settings.TitleFontSize;
	settings.TitleSelFontSize = GetRCInt("TasksTitleSelFontSize", settings.TitleFontSize);
		if (settings.TitleSelFontSize < 2) settings.TitleSelFontSize = settings.TitleFontSize;

	settings.Titles = GetRCBool("TasksTitles", TRUE);
	settings.TitleMinimized = GetRCBool("TasksTitleMinimized", TRUE);
	settings.TitleSelected = GetRCBool("TasksTitleSelected", TRUE);

	settings.TitleNoEllipsis = GetRCBool("TasksTitleNoEllipsis", TRUE);
	settings.TitleMinNoEllipsis = GetRCBool("TasksTitleMinNoEllipsis", TRUE);
	settings.TitleSelNoEllipsis = GetRCBool("TasksTitleSelNoEllipsis", TRUE);

	settings.TitleUnderline = GetRCBool("TasksTitleUnderline", TRUE);
	settings.TitleMinUnderline = GetRCBool("TasksTitleMinUnderline", TRUE);
	settings.TitleSelUnderline = GetRCBool("TasksTitleSelUnderline", TRUE);

	GetRCString("TasksTitleFont", settings.TitleFont, "Arial", 128); // I haven't seen any font names even near 128 in size, no reason to use something larger.
	GetRCString("TasksTitleMinFont", settings.TitleMinFont, settings.TitleFont, 128);
	GetRCString("TasksTitleSelFont", settings.TitleSelFont, settings.TitleFont, 128);

	settings.TitleBgColor = GetRCColor("TasksTitleBgColor", 0xFF00FF);
	settings.TitleMinBgColor = GetRCColor("TasksTitleMinBgColor", settings.TitleBgColor);
	settings.TitleSelBgColor = GetRCColor("TasksTitleSelBgColor", settings.TitleBgColor);

	settings.TitleDarkColor = GetRCColor("TasksTitleDarkColor", 0xFF00FF);
	settings.TitleMinDarkColor = GetRCColor("TasksTitleMinDarkColor", settings.TitleDarkColor);
	settings.TitleSelDarkColor = GetRCColor("TasksTitleSelDarkColor", settings.TitleDarkColor);

	settings.TitleFontColor = GetRCColor("TasksTitleFontColor", 0xC0C0C0); /*'C0C0C0' is a light gray*/
	settings.TitleMinFontColor = GetRCColor("TasksTitleMinFontColor", settings.TitleFontColor);
	settings.TitleSelFontColor = GetRCColor("TasksTitleSelFontColor", settings.TitleFontColor);

	settings.TitleLightColor = GetRCColor("TasksTitleLightColor", 0xFF00FF);
	settings.TitleMinLightColor = GetRCColor("TasksTitleMinLightColor", settings.TitleLightColor);
	settings.TitleSelLightColor = GetRCColor("TasksTitleSelLightColor", settings.TitleLightColor);
	return settings;
}

int initModuleEx(HWND ParentWnd, HINSTANCE dllInst, LPCSTR szPath)
{
	UINT Msgs[2];
	dll = dllInst;
	strcpy(path, szPath);
	parent = ParentWnd;
	screenWidth = GetSystemMetrics(SM_CXSCREEN);
	screenHeight = GetSystemMetrics(SM_CYSCREEN);
	numTasks = 0;
	moveOnce = false;
	curTask = NULL;
	lockCurTask = NULL;
	oldCurTask = NULL;
	captureTask = -1;
	rAllTasks.left = rAllTasks.right = rAllTasks.top = rAllTasks.bottom = 0;
	deskTop = NULL;
	deskTop = FindWindow("DesktopBackgroundClass", NULL);
	if (!deskTop)
		deskTop = GetDesktopWindow();
	{
		WNDCLASS wc;
		memset(&wc,0,sizeof(wc));
		wc.cbClsExtra = NULL;
		wc.cbWndExtra = NULL;
		wc.hbrBackground = NULL;
		wc.hCursor = NULL;
		wc.hIcon = NULL;
		wc.hInstance = dllInst;
		wc.lpfnWndProc = WndProc;
		wc.lpszClassName = szAppName;
		wc.lpszMenuName = NULL;
		wc.style = NULL;
		if (!RegisterClass(&wc))
		{
			MessageBox(parent,"Error registering window class","Tasks",MB_OK);
			return 1;
		}
	}
	movingCursor = LoadCursor(NULL, IDC_UPARROW);
	normalCursor = LoadCursor(NULL, IDC_ARROW);
	if (!normalCursor)
		LoadCursor(NULL, IDC_ARROW);
	ts = ReadSettings();
	if (!ts.NoIcons)
		ReadTasksIcon();
	ReadTasksAdd();
	ReadTasksIgnore();
	ReadTasksPix();
	mainWin = CreateWindowEx(WS_EX_TOOLWINDOW, szAppName, "Timer", WS_CHILD, 0,0,0,0, parent, NULL, dll, NULL);
	if (!mainWin)
	{
		MessageBox(parent,"Error creating window","Tasks",MB_OK);
		return 1;
	}
	if (!ts.NoHints)
	{
		hints = CreateWindow(TOOLTIPS_CLASS,(LPSTR) NULL,TTS_ALWAYSTIP,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,(HMENU) NULL,dll,NULL);
		if (!hints)
		{
			MessageBox(parent, "Error creating hints window", "Tasks", MB_OK);
			return 1;
		}
		SetWindowPos(hints, HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
	}
	{
		Msgs[0] = LM_GETREVID;
		Msgs[1] = 0;
		SendMessage(parent, LM_REGISTERMESSAGE, (WPARAM) mainWin, (LPARAM) Msgs);
	}
	SetWindowLong(mainWin, GWL_USERDATA, 0x49474541);
	ShowWindow(mainWin, SW_HIDE);
	AddBangCommand("!TASKSONBOTTOM", TasksOnBottom);
	AddBangCommand("!TASKSGATHER", TasksGather);
	AddBangCommand("!TASKSHIDE", TasksHide);
	AddBangCommand("!TASKSMOVE", TasksMove);
	AddBangCommand("!TASKSSHOW", TasksShow);
	AddBangCommand("!TASKSSWITCH", TasksSwitch);
	AddBangCommand("!TASKSTOGGLE", TasksToggle);
	AddBangCommand("!TASKSONTOP", TasksOnTop);
	timer = SetTimer(mainWin, 0, 250, NULL);
	//immediately add and update tasks, instead of waiting 250ms for the first round of the timer.
	bFixFocus = false;
	EnumWindows(EnumWindowsProc, NULL);/*Add new apps to tasks list*/
	bFixFocus = true;
	UpdateTasks();/*Update task windows*/
	return 0;
}

void quitModule(HINSTANCE dllInst)
{
	UINT Msgs[2];
	int i;
	if (timer){
		KillTimer(NULL, timer);
	}
	for (i=0;i<numTasks;i++){
		DeleteTask(i);
	} if (tasks){
			free(tasks);
		}

	for (i=0;i<numPix;i++){
		delete [] pixTag[i].match;
		delete [] pixTag[i].pix;
	} if (pixTag){
			free(pixTag);
		}

	for (i=0;i<numIcon;i++){
		delete [] iconTag[i].match;
		delete [] iconTag[i].name;
	} if (iconTag){
			free(iconTag);
		}

	for (i=0;i<numAdd;i++){
		delete [] addTag[i].match;
	} if (addTag){
			free(addTag);
		}

	for (i=0;i<numIgnore;i++){
		delete [] ignoreTag[i].match;
	} if (ignoreTag){
			free(ignoreTag);
		}

	if (ts.BgImage){
		DeleteObject(ts.BgImage);
	} if (ts.MinBgImage){
		DeleteObject(ts.MinBgImage);
	} if (ts.SelBgImage){
		DeleteObject(ts.SelBgImage);
	} if (ts.HideMinAppBar){
		ArrangeIconicWindows(GetDesktopWindow());
	}
	{// unregister the version info litestep message.
		Msgs[0] = LM_GETREVID;
		Msgs[1] = 0;
		SendMessage(parent, LM_UNREGISTERMESSAGE, (WPARAM) mainWin, (LPARAM) Msgs);
	}
	RemoveBangCommand("!TASKSONBOTTOM");
	RemoveBangCommand("!TASKSGATHER");
	RemoveBangCommand("!TASKSHIDE");
	RemoveBangCommand("!TASKSMOVE");
	RemoveBangCommand("!TASKSSHOW");
	RemoveBangCommand("!TASKSSWITCH");
	RemoveBangCommand("!TASKSTOGGLE");
	RemoveBangCommand("!TASKSONTOP");
	if (!ts.NoHints){
		DestroyWindow (hints);
	}
	DestroyWindow(mainWin);
	UnregisterClass(szAppName,dllInst);
	return;
}

void InitializeTask(int i)
{
	tasks[i].pix = NULL;
	tasks[i].icon = NULL;
	tasks[i].IsActive = FALSE;
	tasks[i].IsCustomIcon = FALSE;
	tasks[i].IsIconic = FALSE;
	tasks[i].IsMoved = FALSE;
	return;
}

BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam)
{
	lParam=lParam;
	if (!(numTasks < ts.MaxTiles) && ts.MaxTiles > 0) return FALSE;
	if (!InWinList(hwnd) && IsValidWindow(hwnd))
	{
		if (!tasks)
			tasks = (TaskType *)malloc(sizeof(TaskType));
		else
			tasks = (TaskType *)realloc(tasks, (numTasks+1)*sizeof(TaskType));
		if (tasks == NULL) return FALSE;
		InitializeTask(numTasks); //Icons don't show up if you don't do this... sorta strange...
		CreateTask(numTasks, hwnd);
		++numTasks;
	}
	//if (ts.HideMinAppBar && !InWinList(hwnd) && IsWindow(hwnd) && IsIconic(hwnd)) HideMinAppBar(hwnd);
	return TRUE;
}

BOOL GetTasksAdd(char *addStr)
{
	int i;
	for (i=0;i<numAdd;i++)
	{
		if (strstr(addStr, addTag[i].match))
			return true;
	}
	return false;
}

BOOL GetTasksIgnore(char *ignoreStr)
{
	int i;
	if (!lstrcmpi(ignoreStr, TEXT("WindowsScreenSaverClass")) || !lstrcmpi(ignoreStr, TEXT("tooltips_class32")))
		return true;
	for (i=0;i<numIgnore;i++)
	{
		if (strstr(ignoreStr, ignoreTag[i].match))
			return true;
	}
	return false;
}

BOOL IsAppWindow(HWND hwnd)
{/*This code is from re5ource's Popups*/  // could replace the WS_VISIBLE checks with IsWindowVisible()
	if (!IsWindow(hwnd)) return false;
	BOOL bResult = TRUE;
	LONG nStyle;
	HWND hOwner, hParent;
	RECT r;

	/*if it a WS_VISIBLE, but has zero size fail it. This seems to fix the MDI app bug -jugg*/
	GetClientRect(hwnd, &r);
	nStyle = GetWindowLong(hwnd, GWL_STYLE);
	if(r.right == r.left && r.bottom == r.top && (nStyle & WS_VISIBLE) && !IsIconic(hwnd))
		bResult = FALSE; //was failing minimized windows, so added IsIconic check...

	/*if it is a WS_CHILD or not WS_VISIBLE, fail it*/
	nStyle = GetWindowLong(hwnd, GWL_STYLE);
	if((nStyle & WS_CHILD) || !(nStyle & WS_VISIBLE))
		bResult = FALSE;

	/*if the window is a WS_EX_TOOLWINDOW fail it*/
	nStyle = GetWindowLong(hwnd, GWL_EXSTYLE);
	if(nStyle & WS_EX_TOOLWINDOW)
		bResult = FALSE;

	/*If this has an owner, then only accept this window
		if the partent is not accepted*/
	hOwner = GetWindow(hwnd, GW_OWNER);
	if(hOwner && bResult)
		bResult = FALSE;// !IsAppWindow(hOwner);

	/*if it has a parent, fail*/
	hParent = GetParent(hwnd);
	if(hParent && hParent != GetDesktopWindow())//  && hParent != FindWindow("RunDLL", NULL)) /*Added check so if the parent window is main DesktopWindow don't fail, tho probably unecessary - jugg*/
		bResult = FALSE;

	/*if the magicDWord, fail*/
	if(GetWindowLong(hwnd, GWL_USERDATA) == 0x49474541)
		bResult = FALSE;

	return bResult;
}

BOOL IsValidWindow(HWND hwnd)
{
	BOOL bResult = TRUE;
	char tmpTitle[MAXLEN], tmpClass[MAXLEN];
	GetWindowText(hwnd, (char *)&tmpTitle, MAXLEN);
	GetClassName(hwnd, (char *)&tmpClass, MAXLEN);

	if ( ts.OnlyMinimized && !IsIconic(hwnd) ) bResult = FALSE;
	if ( ts.HideMinimized && IsIconic(hwnd) ) bResult = FALSE;
	if ( GetTasksIgnore(tmpTitle) ) bResult = FALSE;
	if ( GetTasksIgnore(tmpClass) ) bResult = FALSE;
	if ( !(IsAppWindow(hwnd) || GetTasksAdd(tmpTitle) || GetTasksAdd(tmpClass)) ) bResult = FALSE;
	return bResult;
}

HICON GetIconFromWindow(HWND hwnd, BOOL bBigIcon)
{/*This code is a mix from re5ource's Popups and Fahim's lsTasks*/
	HICON a=NULL;
	if (!bBigIcon)
	{
		SendMessageTimeout(hwnd, WM_GETICON, ICON_SMALL, 0, 0, 1000, (unsigned long*)&a);
		if (!a) a = (HICON)GetClassLong(hwnd, GCL_HICONSM);
		if (!a) SendMessageTimeout(hwnd, WM_GETICON, ICON_BIG, 0, 0, 1000, (unsigned long*)&a);
		if (!a) a = (HICON)GetClassLong(hwnd, GCL_HICON);
		if (!a) SendMessageTimeout(hwnd, WM_QUERYDRAGICON, 0, 0, 0, 1000, (unsigned long*)&a);
	} else {
		SendMessageTimeout(hwnd, WM_GETICON, ICON_BIG, 0, 0, 1000, (unsigned long*)&a);
		if (!a) a = (HICON)GetClassLong(hwnd, GCL_HICON);
		if (!a) SendMessageTimeout(hwnd, WM_QUERYDRAGICON, 0, 0, 0, 1000, (unsigned long*)&a);
		if (!a) SendMessageTimeout(hwnd, WM_GETICON, ICON_SMALL, 0, 0, 1000, (unsigned long*)&a);
		if (!a) a = (HICON)GetClassLong(hwnd, GCL_HICONSM);
	}
	if (!a) a = LoadIcon(NULL, MAKEINTRESOURCE(IDI_APPLICATION));
	return a;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case LM_GETREVID:
		{
			char *buf = (char *)lParam;
			if (wParam == 0){
				strcpy(buf, "tasks.dll: ");
				strcat(buf, &rcsRevision[11]);
				buf[strlen(buf)-1] = '\0';
			}
			else if (wParam == 1){
				strcpy(buf, &rcsId[1]);
				buf[strlen(buf)-1] = '\0';
			}else{
				strcpy(buf, "");
			}
			return strlen(buf);
		}
		case WM_TIMER:
		{
			oldCurTask = curTask;
			curTask = GetForegroundWindow();
			if (oldCurTask != curTask)
				lockCurTask = oldCurTask;
			UpdateTasks();/*Update task windows*/
			PackList();/*Get rid of old apps in tasks list*/
			EnumWindows(EnumWindowsProc, NULL);/*Add new apps to tasks list*/
			UpdateTasks();/*Update task windows*/
			return 0;
		}
		case WM_ENDSESSION:
		case WM_QUERYENDSESSION:
			return SendMessage(parent,message,wParam,lParam);
		case WM_ERASEBKGND:
		{
			if (ts.BgColor == 0x00FF00FF || ts.AlwaysOnTop) /* no point in doing this if not transparent.  But because of a wierd quirk must have it when always on top, -jugg*/
			{
				PaintDesktop((HDC)wParam); // transparency (Maduin)
				return 1;
			}
			break;
		}
		case WM_PAINT:
		{
			int n = GetTaskByWnd(hwnd);
			if (n != -1){
				if (ts.UseWindowsSettings)
				{
					PAINTSTRUCT ps;
					HDC hdc = BeginPaint(hwnd,&ps);
					HDC src = CreateCompatibleDC(NULL);
					RECT r;
					GetClientRect(hwnd, &r);
					DrawCaption(tasks[n].appHandle, hdc, &r, (tasks[n].IsActive ? DC_ACTIVE:0)|DC_TEXT|DC_ICON);
					DeleteDC(src);
					EndPaint(hwnd,&ps);
				}else{
					PaintTask(n);
				}
			}
			return 0;
		}
		case WM_DISPLAYCHANGE:
			{// Screen resolution has changed. Update stored settings.
				screenWidth = LOWORD(lParam);
				screenHeight = HIWORD(lParam);
				TasksGather();
				break; // no specified return value, so just "break"ing...
			}
		case WM_LBUTTONDOWN:
		{
			int n = GetTaskByWnd(hwnd);
			if (n != -1)
			{
				GetCursorPos(&oldCursorPos);
				SetCapture(tasks[n].hwnd);
				moveOnce = true;
				captureTask = n;
			}
			return 0;
		}
		case WM_MOUSEMOVE:
		{
			int n = GetTaskByWnd(hwnd);
			if (n != -1 && n == captureTask)
			{
				if ((wParam == MK_LBUTTON) && !ts.NoMove)
				{
					int x,y;
					POINT cursorPos;
					GetCursorPos(&cursorPos);
					if (cursorPos.x == oldCursorPos.x && cursorPos.y == oldCursorPos.y)
					{
						if (GetCursor() != normalCursor)
							SetCursor(normalCursor);
					}
					else
					{
						if (GetCursor() != movingCursor)
							SetCursor(movingCursor);
					}
					x = tasks[n].x - (oldCursorPos.x - cursorPos.x);
					y = tasks[n].y - (oldCursorPos.y - cursorPos.y);
					if (x < 0) x = 0;
					if (y < 0) y = 0;
					if (x + ts.Width > screenWidth) x = screenWidth - ts.Width;
					if (y + ts.Height > screenHeight) y = screenHeight - ts.Height;
					SetWindowPos(tasks[n].hwnd,0,x,y,0,0,SWP_NOSIZE); //SWP_NOZORDER|SWP_NOACTIVATE
					if (ts.BgColor == 0x00FF00FF || moveOnce) /*no point in doing this if not transparent, and do do it the first move no matter what, so it clears clipped junk. -jugg*/
						InvalidateRect(hwnd, NULL, TRUE);/*transparency during move, causes some flicker, but it works (Maduin)*/
					moveOnce = false;
				}
				else
				{
					if (GetCursor() != normalCursor)
						SetCursor(normalCursor);
					if (!ts.NoHints)
					{
						MSG TooltipMessage;
						TooltipMessage.hwnd=tasks[n].hwnd;
						TooltipMessage.message=message;
						TooltipMessage.wParam=wParam;
						TooltipMessage.lParam=lParam;
						SendMessage(hints,TTM_RELAYEVENT,0,(LPARAM)&TooltipMessage);
						SetWindowPos(hints,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
					}
				}
			}
			return 0;
		}
		case WM_LBUTTONUP:
		{
			POINT cursorPos;
			GetCursorPos(&cursorPos);
			int n = GetTaskByWnd(hwnd);
			if (n != -1 && n == captureTask)
			{
				if ((abs(oldCursorPos.x - cursorPos.x) <= ts.DragDistance && abs(oldCursorPos.y - cursorPos.y) <= ts.DragDistance) || ts.NoMove)
				{
					SetWindowPos(tasks[n].hwnd, 0, tasks[n].x, tasks[n].y, ts.Width, ts.Height, NULL); //SWP_NOZORDER|SWP_NOACTIVATE
					if (IsWindowVisible(tasks[n].appHandle)) //if someone uses *TasksAdd to add a window that might turn invisible, we don't want to activate it when invisible.
					{
						if (IsIconic(tasks[n].appHandle))
						{
							ShowWindow(tasks[n].appHandle, SW_RESTORE);
							SendMessage(parent, LM_BRINGTOFRONT, 0, (long)tasks[n].appHandle);/*I think this is for VWM's, so that it changes VW's on task focus... -jugg*/
							SetForegroundWindow(tasks[n].appHandle);
						}
						else if (!ts.NoMinimizeOnClick && (tasks[n].appHandle == curTask || (curTask != tasks[n].appHandle && curTask == tasks[n].hwnd && lockCurTask == tasks[n].appHandle)))
						{
							ShowWindow(tasks[n].appHandle, SW_MINIMIZE);
						}
						else if (!IsIconic(tasks[n].appHandle))
						{
							SendMessage(parent, LM_BRINGTOFRONT, 0, (long)tasks[n].appHandle);/*I think this is for VWM's, so that it changes VW's on task focus... -jugg*/
							SetForegroundWindow(tasks[n].appHandle);
						}
					}else{
						SetForegroundWindow(hwnd == curTask ? lockCurTask:oldCurTask);
					}
					if (ts.HideOnClick)
						TasksHide();
				}
				else if (!ts.NoMove) /*move*/
				{
					tasks[n].x -= oldCursorPos.x - cursorPos.x;
					tasks[n].y -= oldCursorPos.y - cursorPos.y;
					if (ts.MoveAll)
					{
						if (ts.Direction == 1 || (taskWrap && ts.WrapDirection == 1)){
							ts.Y = tasks[n].y + ts.Height;
							if (ts.Y > screenHeight) ts.Y = screenHeight;
						}else{
							ts.Y = tasks[n].y;
							if (ts.Y < 0) ts.Y = 0;
						}
						if (ts.Direction == 4 || (taskWrap && ts.WrapDirection == 4)){
							ts.X = tasks[n].x + ts.Width;
							if (ts.X > screenWidth) ts.X = screenWidth;
						}else{
							ts.X = tasks[n].x;
							if (ts.X < 0) ts.X = 0;
						}
						ReArrangeTasks(true);
					}
					else
					{
						if (tasks[n].x < 0) tasks[n].x = 0;
						if (tasks[n].y < 0) tasks[n].y = 0;
						if (tasks[n].x + ts.Width > screenWidth) tasks[n].x = screenWidth - ts.Width;
						if (tasks[n].y + ts.Height > screenHeight) tasks[n].y = screenHeight - ts.Height;
						SetWindowPos(tasks[n].hwnd, 0, tasks[n].x, tasks[n].y, ts.Width, ts.Height, NULL); //SWP_NOZORDER|SWP_NOACTIVATE
						if (ts.AutoArrange && !tasks[n].IsMoved)
						{
							tasks[n].IsMoved = true;
							ReArrangeTasks(false);
						}
					}
				}/*Have to force a complete redraw here...*/
				//InvalidateRect(tasks[n].hwnd, NULL, TRUE);
			}
			if (GetCursor() != normalCursor)
				SetCursor(normalCursor);
			lockCurTask = NULL;
			captureTask = -1;
			ReleaseCapture();
			return 0;
		}
		//case WM_MOUSEACTIVATE:
		//{
			////PostMessage(parent, 9185, 0, 0); /*Tells litestep it has been selected*/
			////SendMessage(parent, 9183, (int)HIWORD(lParam), (int)LOWORD(lParam)); /*Close any popup open*/
			////return MA_ACTIVATE;
			//return MA_NOACTIVATE;
		//}
			////SendMessage(parent, 9185, 0, 0); /*Tells litestep it has been selected*/
		/*case WM_ACTIVATE:
		{
			if (LOWORD(wParam) == WA_ACTIVE)
				if (GetTaskByWnd((HWND)lParam) == -1 && !IsIconic((HWND)lParam))
					SetForegroundWindow((HWND)lParam);
			return 0;
		}*/
		/*case WM_ACTIVATE:
		{
			if (LOWORD(wParam) == WA_ACTIVE)
			{
				if (GetTaskByWnd((HWND)lParam) == -1 && !IsIconic((HWND)lParam))
					SetActiveWindow((HWND)lParam);
				return 0;
			}
			break;
		}*/
		case WM_RBUTTONUP:
		{
			if (captureTask != -1) break;
			int n = GetTaskByWnd(hwnd);
			if (n != -1)
			{
				if (IsIconic(tasks[n].appHandle)){
					SetForegroundWindow(tasks[n].appHandle);
				}else{
					SendMessage(parent, LM_BRINGTOFRONT, 0, (long)tasks[n].appHandle);
					SetForegroundWindow(tasks[n].appHandle);
				}
//				Sleep(150); //some computers are too fast (or slow?) and need a delay...
				PostMessage(tasks[n].appHandle, 0x313, 0, GetMessagePos()); // Using PostMessage() instead of SendMessage() since it doesn't wait for a return, thus allowing tasks.dll to continue processing.
			}
			return 0;
		}
		case WM_MBUTTONUP: /*LiteStep popup menu*/
		{
			SendMessage(parent, 9182, (int)HIWORD(lParam), (int)LOWORD(lParam));
			return 0;
		}
		//case WM_KEYDOWN:
		//case WM_KEYUP:
			//PostMessage(parent,message,wParam,lParam);
		//return 0;
		/*Capture unwanted closing commands, we only want to exit when LiteStep tells us to*/
		//case WM_DESTROY:
		case WM_CLOSE:
		case WM_SYSCOMMAND:
			return 0;
	}
	return DefWindowProc(hwnd,message,wParam,lParam);
}

int GetTaskByWnd(HWND hwnd)
{
	int i;
	for (i = 0;i < numTasks ; i++)
		if (tasks[i].hwnd == hwnd)
			return i;
	return -1;
}

int GetTaskByAppWnd(HWND hwnd)
{
	int i;
	for (i = 0;i < numTasks ; i++)
		if (tasks[i].appHandle == hwnd)
			return i;
	return -1;
}

int GetUnMovedNrTasks(void)
{
	int result = 0;
	for (int i = 0; i < numTasks; i++)
		if (!tasks[i].IsMoved)
			result++;
	return result;
}

int InWinList(HWND hwnd)
{/*Modified code from stock LS desktop.dll*/
	int i;
	if (!hwnd)
		return 0;
	for (i=0;i<numTasks;i++)
		if (tasks[i].appHandle == hwnd)
			return i+1;
	return 0;
}

void CreateHints(HWND hwnd, char *txt)
{ /*from the original ls code (shortcuts)*/
	RECT r;
	GetClientRect(hwnd, &r);
	TOOLINFO ti;/*tool information*/
	ti.cbSize = sizeof(TOOLINFO);
	ti.uFlags = TTF_SUBCLASS;
	ti.hwnd = hwnd;
	ti.hinst = dll;
	ti.uId = 0;
	ti.lpszText = txt;
	ti.rect = r;
	SendMessage(hints, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);
	return;
}

void CreateTask(int i, HWND handle)
{
	HWND hwnd = NULL;
	char titleTmp[MAXLEN], classTmp[MAXLEN];
	GetNewTaskPos(i);
	/*added code for always ontop -maduin*/
	hwnd = CreateWindowEx(WS_EX_TOOLWINDOW|WS_EX_TOPMOST/*|WS_EX_TRANSPARENT*/, szAppName, "", WS_POPUP, tasks[i].x, tasks[i].y, ts.Width, ts.Height, NULL, NULL, dll, NULL);
	if (!hwnd)
	{
		MessageBox(parent,"Error creating window","Tasks",MB_OK);
		return;
	}
	if (ts.InjTray)
		SetParent(hwnd,FindWindow("jTray", NULL));
	else if (!ts.AlwaysOnTop)
	{
		SetParent(hwnd, deskTop);
		if (bFixFocus){ // don't wanna 'fix' it on recycle/load since it does wierd things.
			if (!IsIconic(handle))
				SetForegroundWindow(handle); //fixes focus bug
			else
				SetForegroundWindow(deskTop);
		}
	}
	tasks[i].hwnd = hwnd;
	tasks[i].appHandle = handle;
	SetWindowLong(tasks[i].hwnd, GWL_USERDATA, 0x49474541);
	{
		GetWindowText(handle, (char *)&titleTmp, MAXLEN);
		tasks[i].appTitle = new char[strlen(titleTmp) + 1];
		strcpy(tasks[i].appTitle, titleTmp);
	}
	{
		GetClassName(handle, (char *)&classTmp, MAXLEN);
		tasks[i].appClass = new char[strlen(classTmp) + 1];
		strcpy(tasks[i].appClass, classTmp);
	}
	tasks[i].IsActive = (GetForegroundWindow() == handle);
	tasks[i].IsIconic = IsIconic(handle);
		if (tasks[i].IsIconic && ts.HideMinAppBar) HideMinAppBar(tasks[i].appHandle);
	tasks[i].IsMoved  = false;
	tasks[i].IsCustomIcon = false;
	if (!ts.NoIcons)
		GetTasksIcon(i);
	GetTasksPix(i);
	if (ts.StartHidden)
		ShowWindow(tasks[i].hwnd, SW_HIDE);
	else
		ShowWindow(tasks[i].hwnd, SW_SHOWNOACTIVATE);
	if (!ts.NoHints)
		CreateHints(tasks[i].hwnd, tasks[i].appTitle);
	return;
}

void DeleteTask(int i)
{
	ShowWindow(tasks[i].hwnd, SW_HIDE);
	if (!ts.NoHints)
		RemoveHints(tasks[i].hwnd);
	if (tasks[i].pix)
		DeleteObject(tasks[i].pix);
	if (tasks[i].appClass)
		delete [] tasks[i].appClass;
	if (tasks[i].appTitle)
		delete [] tasks[i].appTitle;
	if (tasks[i].icon && tasks[i].IsCustomIcon)
		DestroyIcon(tasks[i].icon);
	if (tasks[i].hwnd)
		DestroyWindow(tasks[i].hwnd);
	return;
}

void GetNewTaskPos(int i)
{
	TaskPosition(i, (ts.AutoArrange ? GetUnMovedNrTasks(): numTasks));
	return;
}

void UpdateTasks(void)
{
	int n;
	BOOL refreshTask = false;
	for (n=0;n<numTasks;n++){
		if (tasks[n].IsIconic != IsIconic(tasks[n].appHandle)){
			tasks[n].IsIconic = IsIconic(tasks[n].appHandle);
			if (ts.HighLightMinimized || ts.TitleMinimized || (!ts.TitleMinimized && ts.Titles)){
				refreshTask = true;
			}
		}

		if (curTask == tasks[n].appHandle && IsIconic(tasks[n].appHandle)){
			SetForegroundWindow(deskTop);
			curTask = deskTop;
		}
		if (tasks[n].IsActive != (curTask == tasks[n].appHandle)){
			tasks[n].IsActive = (curTask == tasks[n].appHandle);
			if (ts.HighLightSelected || ts.TitleSelected || (!ts.TitleSelected && ts.Titles)){
				refreshTask = true;
			}
		}

		char tmpTitle[MAXLEN];
		GetWindowText(tasks[n].appHandle, (char *)&tmpTitle, MAXLEN);
		if (strcmp(tmpTitle, tasks[n].appTitle)){
			delete [] tasks[n].appTitle;
			tasks[n].appTitle = new char[strlen(tmpTitle) + 1];
			strcpy(tasks[n].appTitle, tmpTitle);
			if (!ts.NoHints){
				refreshTask = true;
			}
			if ((ts.Titles && !(tasks[n].IsIconic || tasks[n].IsActive)) || (ts.TitleMinimized && tasks[n].IsIconic) || (ts.TitleSelected && tasks[n].IsActive)){
				refreshTask = true;
			}
		}

		if (!tasks[n].IsCustomIcon && !ts.NoIcons && tasks[n].icon != GetIconFromWindow(tasks[n].appHandle, (ts.IconSize > 23) ? true: false))
		{
			tasks[n].icon = GetIconFromWindow(tasks[n].appHandle, (ts.IconSize > 23) ? true: false);
			refreshTask = true;
		}

		if (!ts.StartHidden && refreshTask)
			InvalidateRect(tasks[n].hwnd, NULL, TRUE);
		refreshTask = false;
	}
	return;
}

//void UpdateTasks(void)
//{/*just trust me on this one, its a mess, but everything is needed :) there a several quirks, and some of the code that seems irrelevant is actually fixing little oddities -jugg*/
//	char tmpTitle[MAXLEN];
//	int n;
//	BOOL refreshTask = false;
//	for (n=0; n<numTasks/* && IsWindow(tasks[n].appHandle)*/; n++)
//	{
//		GetWindowText(tasks[n].appHandle, (char *)&tmpTitle, MAXLEN);
//		if (tasks[n].IsIconic != IsIconic(tasks[n].appHandle))
//		{
//			tasks[n].IsIconic = IsIconic(tasks[n].appHandle);
//			if (ts.HideMinAppBar) HideMinAppBar(tasks[n].appHandle);
//			if (tasks[n].IsIconic && tasks[n].IsActive)
//			{/*gotta refresh the task if it had been active and highlighting is turned on*/
//				tasks[n].IsActive = false;
//				if (ts.HighLightSelected)
//					refreshTask = true;
//			}
//			if (ts.TitleMinimized || ts.HighLightMinimized || (!ts.TitleMinimized && (ts.Titles || ts.TitleSelected)))
//				refreshTask = true;
//		}
//		if ((tasks[n].IsActive != (curTask == tasks[n].appHandle)) && ts.HighLightSelected && !tasks[n].IsIconic) /*Strange instance where a minimized window can still be the 'ForegroundWindow'-active?!?*/
//		{
//			if (curTask == tasks[n].appHandle)
//				tasks[n].IsActive = true;
//			else
//				tasks[n].IsActive = false;
//			refreshTask = true;
//		}
//		if (strcmp(tmpTitle, tasks[n].appTitle))
//		{
//			delete [] tasks[n].appTitle;
//			tasks[n].appTitle = new char[strlen(tmpTitle) + 1];
//			strcpy(tasks[n].appTitle, tmpTitle);
//			if (!ts.NoHints) /*This doesn't seem to be updating consistently...-jugg*/
//				UpdateHints(tasks[n].hwnd, tasks[n].appTitle);
//			if ((ts.Titles && !(tasks[n].IsIconic || tasks[n].IsActive)) || (ts.TitleMinimized && tasks[n].IsIconic) || (ts.TitleSelected && tasks[n].IsActive)) /*Have to force a refresh*/
//				refreshTask = true;
//		}
//		if (!tasks[n].IsCustomIcon && !ts.NoIcons && tasks[n].icon != GetIconFromWindow(tasks[n].appHandle, (ts.IconSize > 23) ? true: false))
//		{
//			tasks[n].icon = GetIconFromWindow(tasks[n].appHandle, (ts.IconSize > 23) ? true: false);
//			refreshTask = true;
//		}
//		if (!ts.StartHidden && refreshTask)
//			InvalidateRect(tasks[n].hwnd, NULL, TRUE);
//		refreshTask = false;
//	}
//	return;
//}

void GetTasksIcon(int n)
{
	int i;
	for (i=0;i<numIcon;i++)
	{
		if (strstr(tasks[n].appTitle, iconTag[i].match) || strstr(tasks[n].appClass, iconTag[i].match))
		{
			tasks[n].icon = ExtractIcon(dll,iconTag[i].name,iconTag[i].icon);
			if (tasks[n].icon)
			{
				tasks[n].IsCustomIcon = true;
				return;
			}
		}
	}
	tasks[n].icon = GetIconFromWindow(tasks[n].appHandle, (ts.IconSize > 23) ? true: false);
	return;
}

void GetTasksPix(int n)
{
	int i;
	for (i=0;i<numPix;i++)
	{
		if (strstr(tasks[n].appTitle, pixTag[i].match) || strstr(tasks[n].appClass, pixTag[i].match))
		{
			tasks[n].pix = LoadLSImage(pixTag[i].pix, NULL);
			if (tasks[n].pix)
			{
				tasks[n].icon = NULL;
				return;
			}
		}
	}
	return;
}

void HideMinAppBar(HWND hwnd)
{
	RECT r;
	if (IsIconic(hwnd))
	{
		GetWindowRect(hwnd, &r);
		MoveWindow(hwnd, screenWidth*5+r.left, screenHeight*5+r.top, r.right-r.left, r.bottom-r.top, TRUE);
	}
	return;
}

void PackList(void)
{
	int i,n=numTasks;
	bool b=false;
	for (i=0;i<numTasks||b==true;i++){
		if (b) --i;
		b = false;
		if ( !IsWindow(tasks[i].appHandle) || !IsValidWindow(tasks[i].appHandle) ){
			DeleteTask(i);
			--numTasks;
			if (i<numTasks){
				memmove(&tasks[i], &tasks[i+1], (numTasks-i)*sizeof(TaskType));
				b = true;
			}
		}
	}
	if (n!=numTasks){
		ReArrangeTasks(false);
		tasks = (TaskType *)realloc(tasks, (numTasks)*sizeof(TaskType));
	}
	return;
}

void PaintTask(int i)
{
	int posX, posXpix, posXtmp, posY, posYpix, posYtmp, titleFontSize, titleWidth, titleHeight, titleX, titleY;
	BOOL activeTask = ts.HighLightSelected && tasks[i].IsActive;
	BOOL minTask = ts.HighLightMinimized && tasks[i].IsIconic;
	BOOL minTitles = ts.TitleMinimized && tasks[i].IsIconic;
	BOOL selTitles = ts.TitleSelected && tasks[i].IsActive;
	BOOL normTitles = ts.Titles && !(tasks[i].IsActive || tasks[i].IsIconic);
	BOOL bUnderline, bNoEllipsis;
	CHAR titleFont[MAXLEN];
	COLORREF bgColor, darkColor, lightColor, titleBgColor, titleDarkColor, titleFontColor, titleLightColor;
	PAINTSTRUCT ps;
	BITMAP bmInfo;
	//HBITMAP backImage; /*using a common backImage doesn't seem to work. Not sure why tho. -jugg*/
	HDC hdc = BeginPaint(tasks[i].hwnd,&ps);
	HDC src = CreateCompatibleDC(NULL);
	if (activeTask)
	{
		//backImage = ts.SelBgImage;
		bgColor = ts.SelBgColor;
		lightColor = ts.SelLightColor;
		darkColor = ts.SelDarkColor;
		titleBgColor = ts.TitleSelBgColor;
		titleDarkColor = ts.TitleSelDarkColor;
		titleFontColor = ts.TitleSelFontColor;
		titleLightColor = ts.TitleSelLightColor;
		strcpy(titleFont, ts.TitleSelFont);
		titleFontSize = ts.TitleSelFontSize;
		titleHeight = ts.TitleSelHeight;
		titleWidth = ts.TitleSelWidth;
		titleX = ts.TitleSelX;
		titleY = ts.TitleSelY;
		bNoEllipsis = ts.TitleSelNoEllipsis;
		bUnderline = ts.TitleSelUnderline;
		if (selTitles)
		{
			posX = ts.TitleSelIconX;
			posY = ts.TitleSelIconY;
			posXpix = ts.TitleSelPixX;
			posYpix = ts.TitleSelPixY;
		}else{
			posX = ts.SelIconX;
			posY = ts.SelIconY;
			posXpix = ts.SelPixX;
			posYpix = ts.SelPixY;
		}
	}
	else if (minTask)
	{
		//backImage = ts.MinBgImage;
		bgColor = ts.MinBgColor;
		lightColor = ts.MinLightColor;
		darkColor = ts.MinDarkColor;
		titleBgColor = ts.TitleMinBgColor;
		titleDarkColor = ts.TitleMinDarkColor;
		titleFontColor = ts.TitleMinFontColor;
		titleLightColor = ts.TitleMinLightColor;
		strcpy(titleFont, ts.TitleMinFont);
		titleFontSize = ts.TitleMinFontSize;
		titleHeight = ts.TitleMinHeight;
		titleWidth = ts.TitleMinWidth;
		titleX = ts.TitleMinX;
		titleY = ts.TitleMinY;
		bNoEllipsis = ts.TitleMinNoEllipsis;
		bUnderline = ts.TitleMinUnderline;
		if (minTitles)
		{
			posX = ts.TitleMinIconX;
			posY = ts.TitleMinIconY;
			posXpix = ts.TitleMinPixX;
			posYpix = ts.TitleMinPixY;
		}else{
			posX = ts.MinIconX;
			posY = ts.MinIconY;
			posXpix = ts.MinPixX;
			posYpix = ts.MinPixY;
		}
	}
	else
	{
		//backImage = ts.BgImage;
		bgColor = ts.BgColor;
		lightColor = ts.LightColor;
		darkColor = ts.DarkColor;
		titleBgColor = ts.TitleBgColor;
		titleDarkColor = ts.TitleDarkColor;
		titleFontColor = ts.TitleFontColor;
		titleLightColor = ts.TitleLightColor;
		strcpy(titleFont, ts.TitleFont);
		titleFontSize = ts.TitleFontSize;
		titleHeight = ts.TitleHeight;
		titleWidth = ts.TitleWidth;
		titleX = ts.TitleX;
		titleY = ts.TitleY;
		bNoEllipsis = ts.TitleNoEllipsis;
		bUnderline = ts.TitleUnderline;
		if (normTitles || minTitles || selTitles)
		{
			posX = ts.TitleIconX;
			posY = ts.TitleIconY;
			posXpix = ts.TitlePixX;
			posYpix = ts.TitlePixY;
		}else{
			posX = ts.IconX;
			posY = ts.IconY;
			posXpix = ts.PixX;
			posYpix = ts.PixY;
		}
	}
	{/*paint the background unless transparent*/
		if (bgColor != 0x00FF00FF)
		{
			RECT r;
			GetClientRect(tasks[i].hwnd, &r);
			HBRUSH bg, oldBg;
			bg = CreateSolidBrush(bgColor);
			oldBg = (HBRUSH) SelectObject(hdc, bg);
			FillRect(hdc, &r, bg);
			SelectObject(hdc, oldBg);
			DeleteObject(bg);
			DeleteObject(oldBg);
		}
	}
	if ((ts.BgImage || (ts.SelBgImage && activeTask) || (ts.MinBgImage && minTask)) && !(selBgImgNone && activeTask) && !(minBgImgNone && minTask))
	{/*Paint the background image. Believe me, the above if conditions are all necessary. Odd, but necessary :)*/
		//GetObject(backImage, sizeof(bmInfo), &bmInfo);
		//SelectObject(src, backImage);
		// dde
		HBITMAP hOldBitmap;
		if (ts.MinBgImage && minTask)
		{
			GetObject(ts.MinBgImage, sizeof(bmInfo), &bmInfo);
			//dde
			hOldBitmap = (HBITMAP) SelectObject(src, ts.MinBgImage);
		}
		else if (ts.SelBgImage && activeTask)
		{
			GetObject(ts.SelBgImage, sizeof(bmInfo), &bmInfo);
			//dde
			hOldBitmap = (HBITMAP) SelectObject(src, ts.SelBgImage);
		}
		else
		{
			GetObject(ts.BgImage, sizeof(bmInfo), &bmInfo);
			//dde
			hOldBitmap = (HBITMAP) SelectObject(src, ts.BgImage);
		}
		posXtmp = ts.Width/2 - bmInfo.bmWidth/2;   /*Center in Tile*/
		posYtmp = ts.Height/2 - bmInfo.bmHeight/2;
		TransparentBltLS(hdc, posXtmp, posYtmp, bmInfo.bmWidth, bmInfo.bmHeight, src, 0, 0, RGB(255, 0, 255));
		//dde
		SelectObject (src, hOldBitmap);
		DeleteObject(hOldBitmap);
	}
	if (tasks[i].pix)
	{
		// dde
		HBITMAP hOldPix;
		hOldPix = (HBITMAP) GetObject(tasks[i].pix, sizeof(bmInfo), &bmInfo);
//		if (normTitles || minTitles || selTitles)
//		{
//			posXpix = ts.TitlePixX;
//			posYpix = ts.TitlePixY;
//		}
		SelectObject(src, tasks[i].pix);
		TransparentBltLS(hdc, posXpix, posYpix, bmInfo.bmWidth, bmInfo.bmHeight, src, 0, 0, RGB(255,0,255));
		//dde
		SelectObject (src, hOldPix);
		DeleteObject(hOldPix);
	}
	else if (tasks[i].icon && !ts.NoIcons)
	{
//		if (normTitles || minTitles || selTitles)
//		{
//			posX = ts.TitleIconX;
//			posY = ts.TitleIconY;
//		}
		DrawIconEx(hdc, posX, posY, tasks[i].icon, ts.IconSize, ts.IconSize, 0, NULL, DI_NORMAL);
	}
	if (normTitles || minTitles || selTitles)
	{/*Paint the title boxes - bg/border/text*/
		RECT r;
		GetClientRect(tasks[i].hwnd, &r);
		r.top = titleY;
		r.left = titleX;
		r.bottom = titleHeight + titleY;
		r.right = titleWidth + titleX;

		if (titleBgColor != 0x00FF00FF)
			FillRect(hdc, &r, CreateSolidBrush(titleBgColor));
		if (titleLightColor != 0x00FF00FF)
		{/*Light Color Bevel (left/top)*/
			HPEN pen, oldpen;
			pen = CreatePen(PS_SOLID, 1, titleLightColor);
			oldpen = (HPEN) SelectObject(hdc, pen);
			MoveToEx(hdc, r.left, r.bottom - 1, NULL);
			LineTo(hdc, r.left, r.top);
			LineTo(hdc, r.right - 1, r.top);
			SelectObject(hdc, oldpen);
			DeleteObject(pen);
			DeleteObject(oldpen);
		}
		if (titleDarkColor != 0x00FF00FF)
		{/*Dark Color Bevel (bottom/right)*/
			HPEN pen, oldpen;
			pen = CreatePen(PS_SOLID, 1, titleDarkColor);
			oldpen = (HPEN) SelectObject(hdc, pen);
			MoveToEx(hdc, r.right - 1, r.top, NULL);
			LineTo(hdc, r.right - 1, r.bottom - 1);
			LineTo(hdc, r.left, r.bottom - 1);
			SelectObject(hdc, oldpen);
			DeleteObject(pen);
			DeleteObject(oldpen);
		}
		if (titleFontColor != 0x00FF00FF)
		{
			HFONT Font, oldFont;
			int len = strlen(tasks[i].appTitle);
			r.top += 1;
			r.bottom -= 1;
			r.left += 2;
			r.right -= 2;
			Font = CreateFont(titleFontSize, 0, 0, 0, FW_NORMAL, FALSE, (bUnderline ? TRUE: FALSE), FALSE, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, DEFAULT_PITCH|FF_DONTCARE, titleFont);
			oldFont = (HFONT) SelectObject(hdc, Font);
			SetBkMode(hdc, TRANSPARENT);
			SetTextColor(hdc, titleFontColor);
			DrawText(hdc, tasks[i].appTitle, len, &r, DT_VCENTER|DT_SINGLELINE|(bNoEllipsis ? 0: DT_END_ELLIPSIS));
			SelectObject(hdc, oldFont);
			DeleteObject(Font);
			DeleteObject(oldFont);
		}
	}
	{/*Main task border*/
		RECT r;
		GetClientRect(tasks[i].hwnd, &r);
		if (lightColor != 0x00FF00FF)
		{/*Light Color Bevel (left/top)*/
			HPEN pen, oldpen;
			pen = CreatePen(PS_SOLID, 1, lightColor);
			oldpen = (HPEN) SelectObject(hdc, pen);
			MoveToEx(hdc, r.left, r.bottom - 1, NULL);
			LineTo(hdc, r.left, r.top);
			LineTo(hdc, r.right - 1, r.top);
			SelectObject(hdc, oldpen);
			DeleteObject(pen);
			DeleteObject(oldpen);
		}
		if (darkColor != 0x00FF00FF)
		{/*Dark Color Bevel (bottom/right)*/
			HPEN pen, oldpen;
			pen = CreatePen(PS_SOLID, 1, darkColor);
			oldpen = (HPEN) SelectObject(hdc, pen);
			MoveToEx(hdc, r.right - 1, r.top, NULL);
			LineTo(hdc, r.right - 1, r.bottom - 1);
			LineTo(hdc, r.left, r.bottom - 1);
			SelectObject(hdc, oldpen);
			DeleteObject(pen);
			DeleteObject(oldpen);
		}
	}
	DeleteDC(src);
	EndPaint(tasks[i].hwnd,&ps);
	//if (backImage)
		//DeleteObject(backImage);
	return;
}

bool StripWhiteSpace(char *buffer)
{// strip leading and trailing white space from full String
	int unsigned length = buffer ? strlen (buffer):0;
	while (length && isspace (*buffer))
	{
		length--;
		strcpy (buffer, buffer + 1);
	}
	while (length && isspace (buffer[length-1]))
	{
		buffer[--length] = '\0';
	}
	if (length) return true;
	if (buffer != NULL)
		*buffer = '\0';
	return false;
}

void ReadTasksIcon(void)
{
	FILE * f;
	unsigned int i;
	char * token[4];
	char buffer[1024];
	numIcon = 0;
	f = LCOpen(NULL);
	if (!f)
		return;
	for (i = 0; i < 4; i++)
		token[i] = new char[MAXLEN];
	while (LCReadNextConfig (f, "*TasksIcon", buffer, sizeof (buffer)))
	{
		int count;
		count = LCTokenize (buffer, token, 4, NULL);
		if (count >= 4)
		{
			if (!iconTag)
				iconTag = (IconList *)malloc(sizeof(IconList));
			else
				iconTag = (IconList *)realloc(iconTag, (numIcon+1)*sizeof(IconList));
			iconTag[numIcon].match = new char[strlen(token[1])+1];
			iconTag[numIcon].name = new char[strlen(token[2])+1];
			strcpy(iconTag[numIcon].match, token[1]);
			strcpy(iconTag[numIcon].name, token[2]);
			iconTag[numIcon].icon = atoi(token[3]);
			numIcon++;
		}
	}
	LCClose(f);
	for (i = 0; i < 4; i++)
		delete [] token[i];
	return;
}

void ReadTasksAdd(void)
{
	FILE * f;
	unsigned int i;
	char * token[2];
	char buffer[1024];
	numAdd = 0;
	f = LCOpen(NULL);
	if (!f)
		return;
	for (i = 0; i < 2; i++)
		token[i] = new char[MAXLEN];
	while (LCReadNextConfig (f, "*TasksAdd", buffer, sizeof (buffer)))
	{
		int count;
		count = LCTokenize (buffer, token, 2, NULL);
		if (!StripWhiteSpace(token[1])) continue;
		if (count >= 2)
		{
			if (!addTag)
				addTag = (AddList *)malloc(sizeof(AddList));
			else
				addTag = (AddList *)realloc(addTag, (numAdd+1)*sizeof(AddList));
			addTag[numAdd].match = new char[strlen(token[1])+1];
			strcpy(addTag[numAdd].match, token[1]);
			numAdd++;
		}
	}
	LCClose(f);
	for (i = 0; i < 2; i++)
		delete [] token[i];
	return;
}

void ReadTasksIgnore(void)
{
	FILE * f;
	unsigned int i;
	char * token[2];
	char buffer[1024];
	numIgnore = 0;
	f = LCOpen(NULL);
	if (!f)
		return;
	for (i = 0; i < 2; i++)
		token[i] = new char[MAXLEN];
	while (LCReadNextConfig (f, "*TasksIgnore", buffer, sizeof (buffer)))
	{
		int count;
		count = LCTokenize (buffer, token, 2, NULL);
		if (!StripWhiteSpace(token[1])) continue;
		if (count >= 2)
		{
			if (!ignoreTag)
				ignoreTag = (IgnoreList *)malloc(sizeof(IgnoreList));
			else
				ignoreTag = (IgnoreList *)realloc(ignoreTag, (numIgnore+1)*sizeof(IgnoreList));
			ignoreTag[numIgnore].match = new char[strlen(token[1])+1];
			strcpy(ignoreTag[numIgnore].match, token[1]);
			numIgnore++;
		}
	}
	LCClose(f);
	for (i = 0; i < 2; i++)
		delete [] token[i];
	return;
}

void ReadTasksPix(void)
{
	FILE * f;
	unsigned int i;
	char * token[3];
	char buffer[1024];
	numPix = 0;
	f = LCOpen(NULL);
	if (!f)
		return;
	for (i = 0; i < 3; i++)
		token[i] = new char[MAXLEN];
	while (LCReadNextConfig (f, "*TasksPix", buffer, sizeof (buffer)))
	{
		int count;
		count = LCTokenize (buffer, token, 3, NULL);
		if (count >= 3)
		{
			if (!ignoreTag)
				pixTag = (PixList *)malloc(sizeof(PixList));
			else
				pixTag = (PixList *)realloc(pixTag, (numPix+1)*sizeof(PixList));
			pixTag[numPix].match = new char[strlen(token[1])+1];
			pixTag[numPix].pix = new char[strlen(token[2])+1];
			strcpy(pixTag[numPix].match, token[1]);
			strcpy(pixTag[numPix].pix, token[2]);
			numPix++;
		}
	}
	LCClose(f);
	for (i = 0; i < 3; i++)
		delete [] token[i];
	return;
}

void ReArrangeTasks(BOOL all)
{
	int j = 0;
	for (int i = 0; i < numTasks; i++)
	{
		if (all || !tasks[i].IsMoved)
		{
			TaskPosition(i, j);
			SetWindowPos(tasks[i].hwnd, 0, tasks[i].x, tasks[i].y, ts.Width, ts.Height, NULL); //SWP_NOZORDER|SWP_NOACTIVATE
			j++;
			tasks[i].IsMoved = false; /*when all is true, reset all IsMoved*/
			if (!ts.StartHidden)/*Have to force a complete redraw here...*/
				InvalidateRect(tasks[i].hwnd, NULL, TRUE);
		}
	}
	all = false;
	return;
}

void RemoveHints(HWND hwnd)
{/*from the original ls code (shortcuts)*/
	TOOLINFO ti;/*tool information*/
	RECT r={0,0,0,0};
	ti.cbSize = sizeof(TOOLINFO);
	ti.uFlags = 0;
	ti.hwnd = hwnd;
	ti.hinst = dll;
	ti.uId = 0;
	ti.lpszText = NULL;
	ti.rect = r;
	SendMessage(hints, TTM_DELTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);
	return;
}

void TaskPosition(int i, int tmpNumTasks)
{
	int wrapLine = 0, resetLine = 0; //, checkLine = 0;
	if (taskWrap)
	{
		wrapLine = tmpNumTasks / ts.WrapCount;
		//checkLine = tmpNumTasks - ts.WrapCount * wrapLine;
		//if (checkLine == 1)
			//resetLine = 1;
		//else
			resetLine = tmpNumTasks - ts.WrapCount * wrapLine;
	}
	if (ts.Direction == 1) /*up*/
	{
		if (taskWrap)
		{
			if (ts.Y > 0) // >=0
				tasks[i].y = ts.Y - ts.Height - resetLine * (ts.Height + ts.SpacingY);
			else /*now accepts negative values*/
				tasks[i].y = screenHeight + ts.Y - ts.Height - resetLine * (ts.Height + ts.SpacingY);
			if (ts.WrapDirection == 4) /*left*/
			{
				if (ts.X > 0) // >=0
					tasks[i].x = ts.X - ts.Width - wrapLine * (ts.Width + ts.SpacingX);
				else /*now accepts negative values*/
					tasks[i].x = screenWidth + ts.X - ts.Width - wrapLine * (ts.Width + ts.SpacingX);
			}
			else /*defaults to right, even if user inputs invalid up or down setting*/
			{
				if (ts.X >= 0)
					tasks[i].x = ts.X + wrapLine * (ts.Width + ts.SpacingX);
				else /*now accepts negative values*/
					tasks[i].x = screenWidth + ts.X + wrapLine * (ts.Width + ts.SpacingX);
			}
		}
		else
		{
			if (ts.X >= 0)
				tasks[i].x = ts.X;
			else /*now accepts negative values*/
				tasks[i].x = screenWidth + ts.X;
			if (ts.Y > 0) // >=0
				tasks[i].y = ts.Y - ts.Height - tmpNumTasks * (ts.Height + ts.SpacingY);
			else /*now accepts negative values*/
				tasks[i].y = screenHeight + ts.Y - ts.Height - tmpNumTasks * (ts.Height + ts.SpacingY);
		}
	}
	else if (ts.Direction == 2) /*right*/
	{
		if (taskWrap)
		{
			if (ts.X >= 0)
				tasks[i].x = ts.X + resetLine * (ts.Width + ts.SpacingX);
			else /*now accepts negative values*/
				tasks[i].x = screenWidth + ts.X + resetLine * (ts.Width + ts.SpacingX);
			if (ts.WrapDirection == 1) /*up*/
			{
				if (ts.Y > 0) // >=0
					tasks[i].y = ts.Y - ts.Height - wrapLine * (ts.Height + ts.SpacingY);
				else /*now accepts negative values*/
					tasks[i].y = screenHeight + ts.Y - ts.Height - wrapLine * (ts.Height + ts.SpacingY);
			}
			else /*defaults to down, even if user inputs invalid left or right setting*/
			{
				if (ts.Y >= 0)
					tasks[i].y = ts.Y + wrapLine * (ts.Height + ts.SpacingY);
				else /*now accepts negative values*/
					tasks[i].y = screenHeight + ts.Y + wrapLine * (ts.Height + ts.SpacingY);
			}
		}
		else
		{
			if (ts.X >= 0)
				tasks[i].x = ts.X + tmpNumTasks * (ts.Width + ts.SpacingX);
			else /*now accepts negative values*/
				tasks[i].x = screenWidth + ts.X + tmpNumTasks * (ts.Width + ts.SpacingX);
			if (ts.Y >= 0)
				tasks[i].y = ts.Y;
			else /*now accepts negative values*/
				tasks[i].y = screenHeight + ts.Y;
		}
	}
	else if (ts.Direction == 3) /*down*/
	{
		if (taskWrap)
		{
			if (ts.Y >= 0)
				tasks[i].y = ts.Y + resetLine * (ts.Height + ts.SpacingY);
			else /*now accepts negative values*/
				tasks[i].y = screenHeight + ts.Y + resetLine * (ts.Height + ts.SpacingY);
			if (ts.WrapDirection == 4) /*left*/
			{
				if (ts.X > 0) // >=0
					tasks[i].x = ts.X - ts.Width - wrapLine * (ts.Width + ts.SpacingX);
				else /*now accepts negative values*/
					tasks[i].x = screenWidth + ts.X - ts.Width - wrapLine * (ts.Width + ts.SpacingX);
			}
			else /*defaults to right, even if user inputs invalid up or down setting*/
			{
				if (ts.X >= 0)
					tasks[i].x = ts.X + wrapLine * (ts.Width + ts.SpacingX);
				else /*now accepts negative values*/
					tasks[i].x = screenWidth + ts.X + wrapLine * (ts.Width + ts.SpacingX);
			}
		}
		else
		{
			if (ts.X >= 0)
				tasks[i].x = ts.X;
			else /*now accepts negative values*/
				tasks[i].x = screenWidth + ts.X;
			if (ts.Y >= 0)
				tasks[i].y = ts.Y + tmpNumTasks * (ts.Height + ts.SpacingY);
			else /*now accepts negative values*/
				tasks[i].y = screenHeight + ts.Y + tmpNumTasks * (ts.Height + ts.SpacingY);
		}
	}
	else if (ts.Direction == 4) /*left*/
	{
		if (taskWrap)
		{
			if (ts.X > 0) // >=0
				tasks[i].x = ts.X - ts.Width - resetLine * (ts.Width + ts.SpacingX);
			else /*now accepts negative values*/
				tasks[i].x = screenWidth + ts.X - ts.Width - resetLine * (ts.Width + ts.SpacingX);
			if (ts.WrapDirection == 1) /*up*/
			{
				if (ts.Y > 0) // >=0
					tasks[i].y = ts.Y - ts.Height - wrapLine * (ts.Height + ts.SpacingY);
				else /*now accepts negative values*/
					tasks[i].y = screenHeight + ts.Y - ts.Height - wrapLine * (ts.Height + ts.SpacingY);
			}
			else /*defaults to down, even if user inputs invalid left or right setting*/
			{
				if (ts.Y >= 0)
					tasks[i].y = ts.Y + wrapLine * (ts.Height + ts.SpacingY);
				else /*now accepts negative values*/
					tasks[i].y = screenHeight + ts.Y + wrapLine * (ts.Height + ts.SpacingY);
			}
		}
		else
		{
			if (ts.X > 0) // >=0
				tasks[i].x = ts.X - ts.Width - tmpNumTasks * (ts.Width + ts.SpacingX);
			else /*now accepts negative values*/
				tasks[i].x = screenWidth + ts.X - ts.Width - tmpNumTasks * (ts.Width + ts.SpacingX);
			if (ts.Y >= 0)
				tasks[i].y = ts.Y;
			else /*now accepts negative values*/
				tasks[i].y = screenHeight + ts.Y;
		}
	}
	if (tasks[i].x < rAllTasks.left) rAllTasks.left = tasks[i].x;
	if (tasks[i].x + ts.Width > rAllTasks.right) rAllTasks.right = tasks[i].x + ts.Width;
	if (tasks[i].y < rAllTasks.top) rAllTasks.top = tasks[i].y;
	if (tasks[i].y + ts.Height > rAllTasks.bottom) rAllTasks.bottom = tasks[i].y + ts.Height;
	return;
}

void UpdateHints(HWND hwnd, char *txt)
{
	RECT r;
	GetClientRect(hwnd, &r);
	TOOLINFO ti;
	ti.cbSize = sizeof(TOOLINFO);
	ti.uFlags = TTF_SUBCLASS;
	ti.hwnd = hwnd;
	ti.hinst = dll;
	ti.uId = 0;
	ti.lpszText = txt;
	ti.rect = r;
	SendMessage(hints, TTM_UPDATETIPTEXT, 0, (LPARAM) (LPTOOLINFO) &ti);
	return;
}

/*From here down are the !bang commands*/
void TasksOnBottom(void)
{
	for (int i = 0; i < numTasks; i++)
	{
		SetParent(tasks[i].hwnd, deskTop);
		//SetWindowPos(tasks[i].hwnd,HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE); //|SWP_NOZORDER|SWP_NOACTIVATE
	}
	ts.AlwaysOnTop = false;
	return;
}

void TasksGather(void)
{
	ts.X = bkUpX;
	ts.Y = bkUpY;
	ReArrangeTasks(true);
	return;
}

void TasksHide(void)
{
	for (int i = 0; i < numTasks; i++)
		ShowWindow(tasks[i].hwnd, SW_HIDE);
	ts.StartHidden = true;
	return;
}

void TasksMove(HWND caller, char *args)
{
	caller = caller;
	POINT ps;
	GetCursorPos(&ps);
	ts.X = ps.x;
	ts.Y = ps.y;
	if (args && strlen(args)){
	// can re-use 'args' because strtok stores the orginal value or something :)
		args = strtok(args, "\"\t ,");
			if (args != NULL)
				ts.X = atoi(args);
		args = strtok(NULL, "\"\t ,");
			if (args != NULL)
				ts.Y = atoi(args);
	}else{
		if ((ts.Direction == 4 || (taskWrap && ts.WrapDirection == 4))) ts.X += 1;
		if ((ts.Direction == 1 || (taskWrap && ts.WrapDirection == 1))) ts.Y += 1;
		ReArrangeTasks(true);
		if (rAllTasks.right > screenWidth){
			if (ts.Direction == 4 || (taskWrap && ts.WrapDirection == 4)){
				ts.X = screenWidth;
			}else{
				ts.X -= rAllTasks.right - screenWidth;
			}
		}
		if (rAllTasks.bottom > screenHeight){
			if (ts.Direction == 1 || (taskWrap && ts.WrapDirection == 1)){
				ts.Y = screenHeight;
			}else{
				ts.Y -= rAllTasks.bottom - screenHeight;
			}
		}
		if (rAllTasks.left < 0){
			if (ts.Direction == 4 || (taskWrap && ts.WrapDirection == 4)){
				ts.X -= rAllTasks.left;
			}else{
				ts.X = 0;
			}
		}
		if (rAllTasks.top < 0){
			if (ts.Direction == 1 || (taskWrap && ts.WrapDirection == 1)){
				ts.Y -= rAllTasks.top;
			}else{
				ts.Y = 0;
			}
		}
	}
	rAllTasks.left = rAllTasks.right = rAllTasks.top = rAllTasks.bottom = 0;
	ReArrangeTasks(true);
	return;
}

void TasksShow(void)
{
	for (int i = 0; i < numTasks; i++)
		ShowWindow(tasks[i].hwnd, SW_SHOWNOACTIVATE);
	ts.StartHidden = false;
	return;
}

void TasksSwitch(HWND caller, char *args)
{
	caller=caller;
	bool bNext;
	if (!args && !strlen(args)) return;
	args = strtok(args, "\"\t ");
		if (args !=NULL){
			if (!strcmpi(args, "next")){
				bNext = true;
			}
			else if (!strcmpi(args, "prev")){
				bNext = false;
			}else{
				return;
			}
		}else{
			return;
		}
	int n = GetTaskByAppWnd((GetTaskByWnd(curTask) != -1) ? lockCurTask:curTask);
	if (bNext){
		if (n == -1 || ++n >= numTasks){
			n=0;
		}
	}else{
		if (n == -1 || --n < 0){
			n = numTasks-1;
		}
	}
	if (IsIconic(tasks[n].appHandle)){
		ShowWindow(tasks[n].appHandle, SW_RESTORE);
		SendMessage(parent, LM_BRINGTOFRONT, 0, (long)tasks[n].appHandle);
		SetForegroundWindow(tasks[n].appHandle);
	}else{
		SendMessage(parent, LM_BRINGTOFRONT, 0, (long)tasks[n].appHandle);
		SetForegroundWindow(tasks[n].appHandle);
	}
	return;
}

void TasksToggle(void)
{
	for (int i = 0; i < numTasks; i++)
	{
		if (ts.StartHidden)
			ShowWindow(tasks[i].hwnd, SW_SHOWNOACTIVATE);
		else
			ShowWindow(tasks[i].hwnd, SW_HIDE);
	}
	ts.StartHidden = !ts.StartHidden;
	return;
}

void TasksOnTop(void)
{
	for (int i = 0; i < numTasks; i++)
	{
		SetParent(tasks[i].hwnd, NULL);
		//SetWindowPos(tasks[i].hwnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE); //|SWP_NOZORDER|SWP_NOACTIVATE
	}
	ts.AlwaysOnTop = true;
	return;
}